/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.system.config;

import java.awt.Color;
import java.awt.Component;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.AbstractListModel;
import javax.swing.DefaultListModel;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.ListCellRenderer;
import javax.swing.ListSelectionModel;
import org.visnow.vn.system.main.VisNow;

/**
 *
 * @author gacek
 */
public class PreferencesFavoriteFoldersPanel extends javax.swing.JPanel
{

    /**
     * Creates new form PreferencesFavoriteFoldersPanel
     */
    public PreferencesFavoriteFoldersPanel()
    {
        initComponents();
        list.setCellRenderer(new ListCellRenderer()
        {
            public Component getListCellRendererComponent(
                JList list,
                Object value,
                int index,
                boolean isSelected,
                boolean cellHasFocus)
            {
                JLabel lab;
                if (value instanceof FavoriteFolder) {
                    lab = new JLabel(((FavoriteFolder) value).getName());
                    lab.setIcon(((FavoriteFolder) value).getIcon());
                } else {
                    lab = new JLabel("?");
                }
                if (isSelected) {
                    lab.setOpaque(true);
                    lab.setBackground(Color.LIGHT_GRAY);
                }
                return lab;
            }
        });
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel7 = new JPanel();
        homeButton = new JButton();
        upButton = new JButton();
        downButton = new JButton();
        endButton = new JButton();
        jPanel8 = new JPanel();
        editButton = new JButton();
        addButton = new JButton();
        removeButton = new JButton();
        jScrollPane1 = new JScrollPane();
        list = new JList();

        jPanel7.setName("jPanel7"); // NOI18N
        jPanel7.setLayout(new GridLayout(0, 1, 10, 10));

        homeButton.setText("Home");
        homeButton.setName("homeButton"); // NOI18N
        homeButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                homeButtonActionPerformed(evt);
            }
        });
        jPanel7.add(homeButton);

        upButton.setText("Up");
        upButton.setName("upButton"); // NOI18N
        upButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                upButtonActionPerformed(evt);
            }
        });
        jPanel7.add(upButton);

        downButton.setText("Down");
        downButton.setName("downButton"); // NOI18N
        downButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                downButtonActionPerformed(evt);
            }
        });
        jPanel7.add(downButton);

        endButton.setText("End");
        endButton.setName("endButton"); // NOI18N
        endButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                endButtonActionPerformed(evt);
            }
        });
        jPanel7.add(endButton);

        jPanel8.setName("jPanel8"); // NOI18N

        GroupLayout jPanel8Layout = new GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
                jPanel8Layout.createParallelGroup(Alignment.LEADING)
                        .addGap(0, 93, Short.MAX_VALUE)
                );
        jPanel8Layout.setVerticalGroup(
                jPanel8Layout.createParallelGroup(Alignment.LEADING)
                        .addGap(0, 28, Short.MAX_VALUE)
                );

        jPanel7.add(jPanel8);

        editButton.setText("Edit");
        editButton.setName("editButton"); // NOI18N
        jPanel7.add(editButton);

        addButton.setText("Add");
        addButton.setName("addButton"); // NOI18N
        jPanel7.add(addButton);

        removeButton.setText("Remove");
        removeButton.setName("removeButton"); // NOI18N
        removeButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                removeButtonActionPerformed(evt);
            }
        });
        jPanel7.add(removeButton);

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        list.setModel(new AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };

            public int getSize() {
                return strings.length;
            }

            public Object getElementAt(int i) {
                return strings[i];
            }
        });
        list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        list.setName("list"); // NOI18N
        jScrollPane1.setViewportView(list);

        GroupLayout layout = new GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(Alignment.LEADING)
                        .addGroup(Alignment.TRAILING, layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jScrollPane1, GroupLayout.DEFAULT_SIZE, 271, Short.MAX_VALUE)
                                .addPreferredGap(ComponentPlacement.UNRELATED)
                                .addComponent(jPanel7, GroupLayout.PREFERRED_SIZE, 93, GroupLayout.PREFERRED_SIZE)
                                .addContainerGap())
                );
        layout.setVerticalGroup(
                layout.createParallelGroup(Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(layout.createParallelGroup(Alignment.LEADING)
                                        .addComponent(jPanel7, GroupLayout.PREFERRED_SIZE, 296, GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jScrollPane1, GroupLayout.DEFAULT_SIZE, 316, Short.MAX_VALUE))
                                .addContainerGap())
                );
    }// </editor-fold>//GEN-END:initComponents

    public void init()
    {
        DefaultListModel dlm = new DefaultListModel();
        for (FavoriteFolder ff : VisNow.get().getMainConfig().getFavouriteFolders()) {
            dlm.addElement(ff);
        }
        list.setModel(dlm);
    }

    private void endButtonActionPerformed(ActionEvent evt) {//GEN-FIRST:event_endButtonActionPerformed
        int sel = list.getSelectedIndex();
        if (sel == -1)
            return;
        Object o = ((DefaultListModel) list.getModel()).elementAt(sel);
        ((DefaultListModel) list.getModel()).remove(sel);
        ((DefaultListModel) list.getModel()).add(list.getModel().getSize(), o);
        list.setSelectedIndex(list.getModel().getSize() - 1);
    }//GEN-LAST:event_endButtonActionPerformed

    private void homeButtonActionPerformed(ActionEvent evt) {//GEN-FIRST:event_homeButtonActionPerformed
        int sel = list.getSelectedIndex();
        if (sel == -1)
            return;
        Object o = ((DefaultListModel) list.getModel()).elementAt(sel);
        ((DefaultListModel) list.getModel()).remove(sel);
        ((DefaultListModel) list.getModel()).add(0, o);
        list.setSelectedIndex(0);
    }//GEN-LAST:event_homeButtonActionPerformed

    private void upButtonActionPerformed(ActionEvent evt) {//GEN-FIRST:event_upButtonActionPerformed
        int sel = list.getSelectedIndex();
        if (sel == -1 || sel == 0)
            return;
        Object o = ((DefaultListModel) list.getModel()).elementAt(sel);
        ((DefaultListModel) list.getModel()).remove(sel);
        ((DefaultListModel) list.getModel()).add(sel - 1, o);
        list.setSelectedIndex(sel - 1);
    }//GEN-LAST:event_upButtonActionPerformed

    private void downButtonActionPerformed(ActionEvent evt) {//GEN-FIRST:event_downButtonActionPerformed
        int sel = list.getSelectedIndex();
        if (sel == -1 || sel == list.getModel().getSize() - 1)
            return;
        Object o = ((DefaultListModel) list.getModel()).elementAt(sel);
        ((DefaultListModel) list.getModel()).remove(sel);
        ((DefaultListModel) list.getModel()).add(sel + 1, o);
        list.setSelectedIndex(sel + 1);
    }//GEN-LAST:event_downButtonActionPerformed

    private void removeButtonActionPerformed(ActionEvent evt) {//GEN-FIRST:event_removeButtonActionPerformed
        int sel = list.getSelectedIndex();
        if (sel == -1)
            return;
        ((DefaultListModel) list.getModel()).remove(sel);
    }//GEN-LAST:event_removeButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private JButton addButton;
    private JButton downButton;
    private JButton editButton;
    private JButton endButton;
    private JButton homeButton;
    private JPanel jPanel7;
    private JPanel jPanel8;
    private JScrollPane jScrollPane1;
    private JList list;
    private JButton removeButton;
    private JButton upButton;
    // End of variables declaration//GEN-END:variables

}
